#include "xtop.h"

int _fd2_;
char tmp2[40];
int pstat2;

struct _MemInfo_
{ int MemoryTotal;
  int MemoryFree;
  int Cached;
  int SwapTotal;
  int SwapFree;  
} MemInfo;

void OpenMemInfo();
void CloseMemInfo();
void ReadEOL();
void ReadMemInfo();
//gint _progMemory_ (gpointer data);

gint _progMemory_ (gpointer data)
{
  gfloat perc;
  
  OpenMemInfo();
  ReadMemInfo();
  
  switch (pstat2)
	{ case 0 : perc = ((MemInfo.MemoryFree*100) / MemInfo.MemoryTotal);
	           gtk_progress_bar_update (GTK_PROGRESS_BAR (data),perc );
		   gtk_widget_show(data);
		   pstat2 = 1;
		   break;
		   
          case 1 : perc = ((MemInfo.Cached*100) / MemInfo.MemoryTotal);
		   //gtk_progress_bar_update (GTK_PROGRESS_BAR (data), perc);
		   pstat2 = 2;
		   break;
		   
          case 2 : perc = ((MemInfo.SwapFree*100) / MemInfo.SwapTotal);
	           //gtk_progress_bar_update (GTK_PROGRESS_BAR (data), perc);
		   pstat2 = 0;
		   break;
		   
	}
      CloseMemInfo(); 
      return TRUE;
  }

/*
**	Function name : MemoryInfo(GtkWidget *vbox_Frame)
**
**	Description : 
**	Input :
**	Output : 
**	Last Modification : 31-1
*/
void MemoryInfo(GtkWidget *vbox_Frame)
{ GtkWidget *Frame1;
  GtkWidget *Memory, *Cached, *Swap;
  GtkWidget *vbox_InFrame, *hbox_InFrame;
  GtkWidget *label;
  int ptimer;
  
  pstat2=0;
  
  Frame1 = gtk_frame_new("Load Avarage");
  gtk_box_pack_start(GTK_BOX(vbox_Frame), Frame1, TRUE, TRUE, 2);
  gtk_widget_show(Frame1);
  
  /*Now create the 3 progres bar */
  /* Before all the vbox */
  vbox_InFrame = gtk_vbox_new(TRUE,2);
  gtk_container_add(GTK_CONTAINER(Frame1), vbox_InFrame);
  gtk_widget_show(vbox_InFrame);
  
  /*The 3 progres's bar */
  hbox_InFrame= gtk_hbox_new(FALSE,0);
  gtk_box_pack_start (GTK_BOX (vbox_InFrame), hbox_InFrame, TRUE, TRUE, 0);
  gtk_widget_show(hbox_InFrame);
  
  label = gtk_label_new("Memory   ");
  gtk_misc_set_alignment(GTK_MISC(label),0,0);
  gtk_box_pack_start (GTK_BOX (hbox_InFrame), label, TRUE, TRUE, 0);
  gtk_widget_show(label);
  
  Memory=gtk_progress_bar_new();
  gtk_box_pack_start (GTK_BOX (hbox_InFrame), Memory, TRUE, TRUE, 0);
  gtk_widget_set_usize(Memory,120,10);
  gtk_widget_show(Memory);
  
  hbox_InFrame= gtk_hbox_new(FALSE,0);
  gtk_box_pack_start (GTK_BOX (vbox_InFrame), hbox_InFrame, TRUE, TRUE, 0);
  gtk_widget_show(hbox_InFrame);
  
  label = gtk_label_new("Cached  ");
  gtk_misc_set_alignment(GTK_MISC(label),0,0);
  gtk_box_pack_start (GTK_BOX (hbox_InFrame), label, TRUE, TRUE, 0);
  gtk_widget_show(label);
  
  Cached=gtk_progress_bar_new();
  gtk_box_pack_start (GTK_BOX (hbox_InFrame), Cached, TRUE, TRUE, 0);
  gtk_widget_set_usize(Cached,120,10);
  gtk_widget_show(Cached);
  
  hbox_InFrame= gtk_hbox_new(FALSE,0);
  gtk_box_pack_start (GTK_BOX (vbox_InFrame), hbox_InFrame, TRUE, TRUE, 0);
  gtk_widget_show(hbox_InFrame);
  
  label = gtk_label_new("Swap   ");
  gtk_misc_set_alignment(GTK_MISC(label),0,0);
  gtk_box_pack_start (GTK_BOX (hbox_InFrame), label, TRUE, TRUE, 0);
  gtk_widget_show(label);
  
  Swap=gtk_progress_bar_new();
  gtk_box_pack_start (GTK_BOX (hbox_InFrame), Swap, TRUE, TRUE, 0);
  gtk_widget_set_usize(Swap,120,10);
  gtk_widget_show(Swap);
  
  ptimer = gtk_timeout_add (101, (GtkFunction)_progMemory_, Memory);
  ptimer = gtk_timeout_add (101, _progMemory_, Cached);
  ptimer = gtk_timeout_add (101, _progMemory_, Swap);
  
}

/*
**	Function name : OpenMemInfo
**
**	Description :
**	Input :
**	Output :
**	Last Modification :
*/
void OpenMemInfo()
{ 
  _fd2_ = open("/proc/meminfo",O_RDONLY);
  if (_fd2_ == -1)
    { printf("Errore mentre tento di aprire /proc/meminfo\n");
      exit(-1);
    }
  
}

/*
**	Function name : CloseMemInfo
**
**	Description :
**	Input :
**	Output :
**	Last Modification :
*/
void CloseMemInfo()
{
  close (_fd2_);   
}

/*
**	Function name : ReadEOL
**
**	Description :
**	Input :
**	Output :
**	Last Modification :
*/
void ReadEOL()
{ int done;
    
  tmp2[0] = '\0';
  while (tmp2[0] != '\n')
    { read(_fd2_, &tmp2[0],1);
    }
  
}


/*
**	Function name : ReadMemInfo
**
**	Description :
**	Input :
**	Output :
**	Last Modification :
*/
void ReadMemInfo()
{ int i;
  int done;
  
  /*Skip First 3 lines */
  ReadEOL();
  ReadEOL();
  ReadEOL();
  
  /*done = FALSE;
  i = 0;
  while (done == FALSE)
    { read(_fd2_, &tmp2[i],1);
      printf("%c %d",tmp2[0], tmp2[0]);
      if (tmp2[i++] == '\n')
	done = TRUE;
    }
  */
  
  /*Read MemTotal */
  /* Skip 12 car. */
  for (i = 14; i > 0; i--)
    read(_fd2_, &tmp2[0],1);
  
  bzero(tmp2,40);
  /*Now read Until Space */
  i = -1;
  while (tmp2[i++] != '\n')
    { read(_fd2_, &tmp2[i],1);
    }
  MemInfo.MemoryTotal = atoi(tmp2);
  
  /*Read MemFree */
  /* Skip 12 car. */
  for (i = 14; i > 0; i--)
    read(_fd2_, &tmp2[0],1);
  
  bzero(tmp2,40);
  /*Now read Until Space */
  i = -1;
  while (tmp2[i++] != '\n')
    { read(_fd2_, &tmp2[i],1);
    }
  MemInfo.MemoryFree = atoi(tmp2);
  
  /*Skip 2 lines*/
  ReadEOL();
  ReadEOL();
  
  /* Read Cached Memory */
  /* Skip 12 car. */
  for (i = 14; i > 0; i--)
    read(_fd2_, &tmp2[0],1);
  
  bzero(tmp2,40);
  /*Now read Until Space */
  i = -1;
  while (tmp2[i++] != '\n')
    { read(_fd2_, &tmp2[i],1);
    }
  MemInfo.Cached = atoi(tmp2);
  
  /* Read SwapTotal */
  /* Skip 12 car. */
  for (i = 14; i > 0; i--)
    read(_fd2_, &tmp2[0],1);
  
  bzero(tmp2,40);
  /*Now read Until Space */
  i = -1;
  while (tmp2[i++] != '\n')
    { read(_fd2_, &tmp2[i],1);
    }
  MemInfo.SwapTotal = atoi(tmp2);
  
  /* Read SwapFree */
  /* Skip 12 car. */
  for (i = 14; i > 0; i--)
    read(_fd2_, &tmp2[0],1);
  
  bzero(tmp2,40);
  /*Now read Until Space */
  i = 0;
  while (done > 0)
    { done = read(_fd2_, &tmp2[i++],1);
    }
  MemInfo.SwapFree = atoi(tmp2);
  
}


